document.documentElement.getButton("extra2").type = "menu";
document.documentElement.getButton("extra2").setAttribute("popup", "settingsPopup");
  
/* restore GMF settings */
function gmfDefault() {
	var preferences = document.getElementsByTagName("preference");
	
	for (let preference of preferences) {
		preference.value = preference.defaultValue == null ? undefined : preference.defaultValue;
	}
}

/* export GMF settings */
function gmfExport() {

  var patterns = new Array;
  
  var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.glassmyfox-extension.");
	
	patterns[0]="GMFpreferences-DO_NOT_EDIT";
	patterns[1]="mainwindowglass="+prefs.getBoolPref("mainwindowglass");
	patterns[2]="gmftabset:"+prefs.getCharPref("gmftabset");
	patterns[3]="libraryglass~"+prefs.getIntPref("libraryglass");
	patterns[4]="preferencesglass~"+prefs.getIntPref("preferencesglass");
	patterns[5]="dropdownbg~"+prefs.getIntPref("dropdownbg");
	patterns[6]="dlwindowglass="+prefs.getBoolPref("dlwindowglass");
	patterns[7]="buttonglass="+prefs.getBoolPref("buttonglass");
	patterns[8]="navbarbuttonglass="+prefs.getBoolPref("navbarbuttonglass");
	patterns[9]="tooltipglass="+prefs.getBoolPref("tooltipglass");
	patterns[10]="urlsearchbarglass~"+prefs.getIntPref("urlsearchbarglass");
	patterns[11]="appbutton~"+prefs.getIntPref("appbutton");
	patterns[12]="appbuttonicon="+prefs.getBoolPref("appbuttonicon");
	patterns[13]="toolbartc~"+prefs.getIntPref("toolbartc");
	patterns[14]="toolbartcc:"+prefs.getCharPref("toolbartcc");
	patterns[15]="toolbartccshadow:"+prefs.getCharPref("toolbartccshadow");
	patterns[16]="dropdowntc~"+prefs.getIntPref("dropdowntc");
	patterns[17]="dropdowntcc:"+prefs.getCharPref("dropdowntcc");
	patterns[18]="dropdowntccshadow:"+prefs.getCharPref("dropdowntccshadow");
	patterns[19]="sidebartc~"+prefs.getIntPref("sidebartc");
	patterns[20]="sidebartcc:"+prefs.getCharPref("sidebartcc");
	patterns[21]="tabswt="+prefs.getBoolPref("tabswt");
	patterns[22]="hightabs="+prefs.getBoolPref("hightabs");
	patterns[23]="tabclose="+prefs.getBoolPref("tabclose");
	patterns[24]="whitetbbut="+prefs.getBoolPref("whitetbbut");
	patterns[25]="highbookm="+prefs.getBoolPref("highbookm");
	patterns[26]="mseperator="+prefs.getBoolPref("mseperator");
	patterns[27]="menubarmorespace="+prefs.getBoolPref("menubarmorespace");
	patterns[28]="toolbartopbgst="+prefs.getBoolPref("toolbartopbgst");
	patterns[29]="toolbarbottombgst="+prefs.getBoolPref("toolbarbottombgst");
	patterns[30]="ff13newtabglass="+prefs.getBoolPref("ff13newtabglass");
	patterns[31]="abouttabglass="+prefs.getBoolPref("abouttabglass");
	patterns[32]="contentglass="+prefs.getBoolPref("contentglass");
	patterns[33]="noappcontentgradient="+prefs.getBoolPref("noappcontentgradient");
	patterns[34]="sidebarglass~"+prefs.getIntPref("sidebarglass");
	patterns[35]="prefswt="+prefs.getBoolPref("prefswt");
	patterns[36]="textboxtc~"+prefs.getIntPref("textboxtc");
	patterns[37]="textboxtcc:"+prefs.getCharPref("textboxtcc");
	patterns[38]="textboxtccshadow:"+prefs.getCharPref("textboxtccshadow");
	patterns[39]="expfindbar25="+prefs.getBoolPref("expfindbar25");

  saveToFile(patterns);
  return true;
}

function saveToFile(patterns) {

  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

  fp.init(window, null, nsIFilePicker.modeSave);
  fp.defaultExtension = "txt";
  fp.defaultString = "GMFprefs.txt";
  fp.appendFilters(nsIFilePicker.filterText);

  if (fp.show() != nsIFilePicker.returnCancel) {
    let file = fp.file;
    if (!/\.txt$/.test(file.leafName.toLowerCase()))
      file.leafName += ".txt";
    if (file.exists())
      file.remove(true);
    file.create(file.NORMAL_FILE_TYPE, parseInt("0666", 8));
    stream.init(file, 0x02, 0x200, null);

    for (var i = 0; i < patterns.length ; i++) {
      patterns[i]=patterns[i]+"\n";
      stream.write(patterns[i], patterns[i].length);
    }
    stream.close();
  }
}

/* import GMF settings */
function gmfImport() {
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.glassmyfox-extension.");
   
   var pattern = loadFromFile();

   if (!pattern) return false;
   
   if(pattern[0]!="GMFpreferences-DO_NOT_EDIT") {
      alert('Wrong file! Nothing was imported!\nUngueltige Datei! Es wurde nichts importiert!');
	  return false;
   }

   var i, prefName, prefValue;
   
   for (i=1; i<pattern.length; i++){
      var index1 = pattern[i].indexOf("="); // for booleans
	  var index2 = pattern[i].indexOf(":"); // for strings
	  var index3 = pattern[i].indexOf("~"); // for ints
      
	  if (index1 > 0){ // find bool
         prefName  = pattern[i].substring(0,index1);
         prefValue = pattern[i].substring(index1+1,pattern[i].length);

		 // if prefValue string is "true" -> true, else -> false
		 prefs.setBoolPref(''+prefName+'',(prefValue === 'true'));
      }
	  else if (index2 > 0){ // find string
         prefName  = pattern[i].substring(0,index2);
         prefValue = pattern[i].substring(index2+1,pattern[i].length);
		 
		 prefs.setCharPref(''+prefName+'',''+prefValue+'');
      }
	  else if (index3 > 0){ // find int
         prefName  = pattern[i].substring(0,index3);
         prefValue = pattern[i].substring(index3+1,pattern[i].length);
		 
		 prefs.setIntPref(''+prefName+'',prefValue);
      }
   }

   return true;
}

function loadFromFile() {

   const nsIFilePicker = Components.interfaces.nsIFilePicker;
   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
   var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
   var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);

   fp.defaultExtension = "txt";
   fp.defaultString = "GMFprefs.txt";
   fp.init(window, null, nsIFilePicker.modeOpen);
   fp.appendFilters(nsIFilePicker.filterText);

   if (fp.show() != nsIFilePicker.returnCancel) {
      stream.init(fp.file, 0x01, parseInt("0444", 8), null);
      streamIO.init(stream);
      var input = streamIO.read(stream.available());
      streamIO.close();
      stream.close();

      var linebreak = input.match(/(((\n+)|(\r+))+)/m)[1];
      return input.split(linebreak);
   }
   return null;
}